<template>
  <div class="bg-gray-200 rounded-md p-3">
    <h1 class="text-2xl text-gray-800">{{ title }}</h1>
    <div class="flex flex-col space-y-10">
      <div class="w-full text-center text-gray-600 font-bold text-lg">
        <p>Tabla 1 Turnos No Asignados</p>
        <table
          class="table-auto border-separate border border-green-800 text-xs"
        >
          <thead>
            <tr class="text-gray-700">
              <th class="border-2 border-gray-900"></th>
              <th
                v-for="date in dateList"
                :key="date"
                class="border-2 border-gray-900"
              >
                {{ date }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td class="border-2 border-gray-900">TURNOS NO ASIGNADOS</td>
              <td v-for="date in dateList" :key="date">
                <div
                  v-for="turn in freeTurnList[date]"
                  :key="turn"
                  class="border-2 border-gray-900"
                >
                  {{ turn.turnTemplateName }}
                  ({{ turn.turnTemplateCheckIn }}-{{
                    turn.turnTemplateCheckOut
                  }})
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <div class="w-full text-center text-blue-500 font-bold text-lg">
        <p>Tabla 2 Turnos Asignados</p>
        <table
          class="
            table-auto
            border-separate border border-gray-800
            text-xs text-gray-800
          "
        >
          <thead>
            <tr class="text-gray-700">
              <th>Turnos asignados</th>
              <th
                v-for="date in dateList"
                :key="date"
                class="border-2 border-gray-900"
              >
                {{ date }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td class="border-2 border-gray-800">Usuario asignado</td>
              <td v-for="date in dateList" :key="date">
                <div
                  v-for="turn in turnList[date]"
                  :key="turn"
                  class="border-2 border-gray-900"
                >
                  {{ turn.turnTemplateName }}
                  ({{ turn.turnTemplateCheckIn }}-{{
                    turn.turnTemplateCheckOut
                  }})
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import getUsers from '../helpers/getUsers.js';
import getTurnTemplates from '../helpers/getTurnTemplates.js';
import getTurns from '../helpers/getTurns.js';
import onlyUnique from '../helpers/onlyUnique.js';
export default {
  data() {
    return {
      title: 'Turnos',
      dateList: [],
      turnList: [],
      freeTurnList: [],
    };
  },
  async created() {
    try {
      this.turnTemplatesList = await getTurnTemplates();
      this.turnList = await getTurns();
      this.usersList = await getUsers();
      // sacar fechas sin repetir
      this.dateList = this.turnList
        .map((turn) => turn.date)
        .sort((a, b) => (a > b ? 1 : a < b ? -1 : 0))
        .filter(onlyUnique);
      // turnos libres
      this.freeTurnList = this.turnList.filter(
        (turn) => turn.userId.length == 0
      );
      const turnTemplatesList = this.turnTemplatesList;
      this.freeTurnList.forEach(async function (turn) {
        turnTemplatesList.forEach(function (turnTemplate) {
          if (turn.turnTemplateId == turnTemplate.id) {
            turn.turnTemplateCheckIn = turnTemplate.checkIn;
            turn.turnTemplateCheckOut = turnTemplate.checkOut;
            turn.turnTemplateName = turnTemplate.name;
          }
        });
      });
      // turnos asignados
      this.turnList = this.turnList.filter((turn) => turn.userId.length > 0);
      this.turnList.forEach(async function (turn) {
        turnTemplatesList.forEach(function (turnTemplate) {
          if (turn.turnTemplateId == turnTemplate.id) {
            turn.turnTemplateCheckIn = turnTemplate.checkIn;
            turn.turnTemplateCheckOut = turnTemplate.checkOut;
            turn.turnTemplateName = turnTemplate.name;
          }
        });
      });
      // asignar arrys como fechas para mostrarlas
      const freeTurnList = this.freeTurnList;
      const turnList = this.turnList;
      //const usersList = this.usersList;
      this.dateList.forEach(async function (date) {
        freeTurnList[date] = freeTurnList.filter((turn) => turn.date == date);
        turnList[date] = turnList.filter((turn) => turn.date == date);
        /*
        const dateTemp = date;
        usersList.forEach(async function (user) {
          turnList[dateTemp][user.id] = turnList.filter(
            (turn) => turn.date == dateTemp && turn.userId.includes(user.id)
          );
        });
        */
      });
    } catch (e) {
      this.errors.push(e);
    }
  },
};
</script>
